# `OpenSSH_jll.jl` (v8.1.0+0)

This is an autogenerated package constructed using [`BinaryBuilder.jl`](https://github.com/JuliaPackaging/BinaryBuilder.jl). The originating [`build_tarballs.jl`](https://github.com/JuliaPackaging/Yggdrasil/blob/385f1510739d06bff85f5713ba5a48f0a9a1beeb/O/OpenSSH/build_tarballs.jl) script can be found on [`Yggdrasil`](https://github.com/JuliaPackaging/Yggdrasil/), the community build tree.

For more details about JLL packages and how to use them, see `BinaryBuilder.jl` [documentation](https://juliapackaging.github.io/BinaryBuilder.jl/dev/jll/).

## Sources

The tarballs for `OpenSSH_jll.jl` have been built from these sources:

* git repository: https://github.com/openssh/openssh-portable.git (revision: `cdf1d0a9f5d18535e0a18ff34860e81a6d83aa5c`)
* compressed archive: https://github.com/PowerShell/Win32-OpenSSH/releases/download/v8.1.0.0p1-Beta/OpenSSH-Win32.zip (SHA256 checksum: `88aaf9eafc64a11d2ba0894a1c24608f1b6d69408b19bb7b15287338fea76dd0`)
* compressed archive: https://github.com/PowerShell/Win32-OpenSSH/releases/download/v8.1.0.0p1-Beta/OpenSSH-Win64.zip (SHA256 checksum: `c99240af89452610f66b7ce54c4fa3180b66aae2bc326afc2aac8fc1dd48f488`)
* files in directory, relative to originating `build_tarballs.jl`: [`./bundled`](https://github.com/JuliaPackaging/Yggdrasil/tree/385f1510739d06bff85f5713ba5a48f0a9a1beeb/O/OpenSSH/bundled)

## Platforms

`OpenSSH_jll.jl` is available for the following platforms:

* `Linux(:aarch64, libc=:glibc)` (`aarch64-linux-gnu`)
* `Linux(:aarch64, libc=:musl)` (`aarch64-linux-musl`)
* `Linux(:armv7l, libc=:glibc, call_abi=:eabihf)` (`armv7l-linux-gnueabihf`)
* `Linux(:armv7l, libc=:musl, call_abi=:eabihf)` (`armv7l-linux-musleabihf`)
* `Linux(:i686, libc=:glibc)` (`i686-linux-gnu`)
* `Linux(:i686, libc=:musl)` (`i686-linux-musl`)
* `Windows(:i686)` (`i686-w64-mingw32`)
* `Linux(:powerpc64le, libc=:glibc)` (`powerpc64le-linux-gnu`)
* `MacOS(:x86_64)` (`x86_64-apple-darwin14`)
* `Linux(:x86_64, libc=:glibc)` (`x86_64-linux-gnu`)
* `Linux(:x86_64, libc=:musl)` (`x86_64-linux-musl`)
* `FreeBSD(:x86_64)` (`x86_64-unknown-freebsd11.1`)
* `Windows(:x86_64)` (`x86_64-w64-mingw32`)

## Dependencies

The following JLL packages are required by `OpenSSH_jll.jl`:

* [`OpenSSL_jll`](https://github.com/JuliaBinaryWrappers/OpenSSL_jll.jl)
* [`Zlib_jll`](https://github.com/JuliaBinaryWrappers/Zlib_jll.jl)

## Products

The code bindings within this package are autogenerated from the following `Products`:

* `ExecutableProduct`: `scp`
* `ExecutableProduct`: `ssh`
* `ExecutableProduct`: `ssh_add`
* `ExecutableProduct`: `ssh_agent`
* `ExecutableProduct`: `ssh_keygen`
* `ExecutableProduct`: `ssh_keyscan`
